"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignInForm = exports.SignInFields = void 0;
var react_1 = __importStar(require("react"));
var single_line_input_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/input/single-line-input"));
var checkbox_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/checkbox"));
var types_1 = require("primeobjects-ui-web-form/build/cjs/fields/types");
var message_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/message"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var lodash_1 = require("lodash");
var row_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/row"));
var codes_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/codes"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
// import { useSolution } from "primeobjects-helper-ui";
var SuccessMesaage = function (props) {
    return (react_1.default.createElement(message_1.default, { wrapperClassName: "mb-4", hideIcon: true, type: "success", line: props.line, lineStyle: { fontSize: "110%", lineHeight: 1.4 } }));
};
var SignInFields = function (props) {
    var onChangeData = props.onChangeData, disabled = props.disabled, alwaysShowLabel = props.alwaysShowLabel;
    var data = (0, core_1.isObject)(props.data) ? props.data : {};
    //const solution = useSolution();
    // const primaryColor = usePrimaryColor(solution);
    var showCodes = data.action == "activate-with-password" ||
        data.action == "activate-without-password" ||
        data.action == "activate-reset-password" ||
        data.result == "sign-up-success";
    var onPressEnterPassword = function () {
        if ((0, lodash_1.isFunction)(props.onSubmitPassword))
            props.onSubmitPassword(data);
    };
    var onPressEnterEmail = function () {
        if ((0, lodash_1.isFunction)(props.onSubmitEmail))
            props.onSubmitEmail(data);
    };
    var onChangeRememberMe = function () {
        if ((0, lodash_1.isFunction)(props.onChangeRememberMe))
            props.onChangeRememberMe(data);
    };
    var onClickResendCodes = function () {
        if ((0, lodash_1.isFunction)(props.onClickResendCodes))
            props.onClickResendCodes(data);
    };
    var renderRememberMe = function () {
        if (!(0, lodash_1.isFunction)(props.onChangeRememberMe) ||
            data.action == "reset-password" ||
            data.action == "activate-without-password" ||
            data.action == "activate-with-password")
            return null;
        // if (!AntCheckbox) AntCheckbox = logDynamic(dynamic(() => import('../../../controls/antd/checkbox'), { ssr: false }), '../../../controls/antd/checkbox','Helper.SignInFields');
        return (react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(checkbox_1.default, { id: "readme", inputSize: types_1.FIELD_INPUT_SIZE.SMALL, disabled: disabled, value: data.rememberMe == true, onChange: onChangeRememberMe, label: "Remember me" })));
    };
    var onKeyPress = function () {
        onChangeData("keyPressedOn", (0, primeobjects_helper_util_1.getTimestamp)());
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        (data.result == "send-verification-success" ||
            data.result == "sign-up-success") && (react_1.default.createElement(SuccessMesaage, { line: "Thank you! The verification code has been sent to your ".concat((data === null || data === void 0 ? void 0 : data.type) == "mobile"
                ? "mobile phone"
                : "email address", ".") })),
        data.result == "activate-user-without-password-success" && (react_1.default.createElement(SuccessMesaage, { line: "Thank you! Your user account has been activated successfully." })),
        data.result == "activate-user-with-password-success" && (react_1.default.createElement(SuccessMesaage, { line: "Thank you! Your password has been reset successfully." })),
        data.codeSent == "reset-password" && (react_1.default.createElement(SuccessMesaage, { line: "Thank you! The password reset link has been sent to your ".concat((data === null || data === void 0 ? void 0 : data.type) == "mobile"
                ? "mobile phone"
                : "email address", ".") })),
        react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(single_line_input_1.default, { id: "email", labelClassName: "font-semibold", onChange: function (v) { return onChangeData("email", v); }, onKeyPress: onKeyPress, onSubmit: onPressEnterEmail, disabled: disabled, format: "email", borderType: "bottom", placeholder: "Type your email here", value: (0, core_1.isNonEmptyString)(data.email) ? data.email : "", alwaysShowLabel: alwaysShowLabel, label: "Your email address" })),
        showCodes && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(row_1.default, null,
                react_1.default.createElement(codes_1.default, { id: "code", labelClassName: "font-semibold", onChange: function (v) { return onChangeData("code", v); }, disabled: disabled, value: (0, core_1.isNonEmptyString)(data.code) ? data.code : "", alwaysShowLabel: alwaysShowLabel, label: "Your verification code", onKeyPress: onKeyPress })),
            react_1.default.createElement(row_1.default, null,
                react_1.default.createElement("div", { className: "underline cursor-pointer text-sky-500 mb-4", onClick: onClickResendCodes }, "Click here to resent the verification code.")))),
        data.action != "reset-password" &&
            data.action != "activate-without-password" && (react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(single_line_input_1.default, { id: "password", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) {
                    return onChangeData("password", v);
                }, onKeyPress: onKeyPress, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Type your password here", label: "Your password", alwaysShowLabel: alwaysShowLabel, value: (0, core_1.isNonEmptyString)(data.password)
                    ? data.password
                    : "" }))),
        (data.action == "activate-with-password" ||
            data.action == "activate-reset-password") && (react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(single_line_input_1.default, { id: "confirmPassword", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) {
                    return onChangeData("confirmPassword", v);
                }, onKeyPress: onKeyPress, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Confirm your password here", label: "Confirm your password", alwaysShowLabel: alwaysShowLabel, value: (0, core_1.isNonEmptyString)(data.confirmPassword)
                    ? data.confirmPassword
                    : "" }))),
        renderRememberMe()));
};
exports.SignInFields = SignInFields;
var SignInForm = function (props) {
    var _a, _b, _c, _d, _e;
    var alwaysShowLabel = props.alwaysShowLabel;
    var _f = (0, react_1.useState)(props.doing), doing = _f[0], setDoing = _f[1];
    var _g = (0, react_1.useState)(props.errorMessage), errorMessage = _g[0], setErrorMessage = _g[1];
    var _h = (0, react_1.useState)({}), data = _h[0], setData = _h[1];
    (0, react_1.useEffect)(function () {
        setData(props.data);
    }, [props.data]);
    (0, react_1.useEffect)(function () {
        setErrorMessage(props.errorMessage);
    }, [props.errorMessage]);
    (0, react_1.useEffect)(function () {
        setDoing(props.doing);
    }, [props.doing]);
    var onChangeData = function (fieldName, value) {
        setErrorMessage("");
        data[fieldName] = value;
        setData(__assign({}, data));
        if ((0, lodash_1.isFunction)(props.onChangeData))
            props.onChangeData(data);
    };
    var onSubmitPassword = function () {
        if ((0, lodash_1.isFunction)(props.onSubmitPassword))
            props.onSubmitPassword(data);
    };
    var onSubmitEmail = function () {
        if ((0, lodash_1.isFunction)(props.onSubmitEmail))
            props.onSubmitEmail(data);
    };
    var onChangeRememberMe = function () {
        onChangeData("rememberMe", data.rememberMe == true ? false : true);
    };
    var onClickResendCodes = function () {
        if ((0, lodash_1.isFunction)(props.onClickResendCodes))
            props.onClickResendCodes(data);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        (0, core_1.isNonEmptyString)((_a = props.message) === null || _a === void 0 ? void 0 : _a.contnet) && (react_1.default.createElement(message_1.default, { wrapperClassName: "mb-4", hideIcon: true, line: (_b = props.message) === null || _b === void 0 ? void 0 : _b.contnet, type: ((_c = props.message) === null || _c === void 0 ? void 0 : _c.type) ? (_d = props.message) === null || _d === void 0 ? void 0 : _d.type : "success", hidden: !(0, core_1.isNonEmptyString)((_e = props.message) === null || _e === void 0 ? void 0 : _e.contnet) })),
        react_1.default.createElement(exports.SignInFields, { onClickResendCodes: onClickResendCodes, onChangeRememberMe: onChangeRememberMe, onSubmitPassword: onSubmitPassword, onSubmitEmail: onSubmitEmail, alwaysShowLabel: alwaysShowLabel, data: data, onChangeData: onChangeData, disabled: doing }),
        props.children,
        react_1.default.createElement(message_1.default, { hideIcon: true, line: errorMessage, type: "error", hidden: !(0, core_1.isNonEmptyString)(errorMessage) })));
};
exports.SignInForm = SignInForm;
exports.default = exports.SignInForm;
//# sourceMappingURL=sign-in.js.map