var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from "react";
import SingleLineInputField from "primeobjects-ui-web-form/build/cjs/fields/input/single-line-input";
import PicklistField from "primeobjects-ui-web-form/build/cjs/fields/picklist";
import { CheckboxField } from "primeobjects-ui-web-form/build/cjs/fields/checkbox";
import MessageField from "primeobjects-ui-web-form/build/cjs/fields/message";
import { isObject, isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import { isFunction, map } from "lodash";
import RowField from "primeobjects-ui-web-form/build/cjs/fields/row";
import { useSolution } from "primeobjects-helper-ui";
import LabelField from "primeobjects-ui-web-form/build/cjs/fields/label";
import LinkField from "primeobjects-ui-web-form/build/cjs/fields/link";
export var SignUpFields = function (props) {
    var onChangeData = props.onChangeData, disabled = props.disabled, alwaysShowLabel = props.alwaysShowLabel, agreement = props.agreement, onShowAgreement = props.onShowAgreement;
    var data = isObject(props.data) ? props.data : {};
    var _a = useState([]), roles = _a[0], setRoles = _a[1];
    var solution = useSolution();
    // const primaryColor = usePrimaryColor(solution);
    useEffect(function () {
        var _a, _b;
        var signUpRoles = (_b = (_a = solution === null || solution === void 0 ? void 0 : solution.signUp) === null || _a === void 0 ? void 0 : _a.roles) !== null && _b !== void 0 ? _b : [];
        setRoles(map(signUpRoles, function (r) {
            return { text: r.title, value: r.value };
        }));
        switch (signUpRoles.length) {
            case 0: {
                onChangeData("role", "ORG-ADMIN");
                break;
            }
            default: {
                onChangeData("role", signUpRoles[0].value);
                break;
            }
        }
    }, [solution.roles]);
    var onPressEnterPassword = function () {
        if (isFunction(props.onSubmitPassword))
            props.onSubmitPassword(data);
    };
    var onPressEnterConfirmPassword = function () {
        if (isFunction(props.onSubmitConfirmPassword))
            props.onSubmitConfirmPassword(data);
    };
    var onPressEnterEmail = function () {
        if (isFunction(props.onSubmitEmail))
            props.onSubmitEmail(data);
    };
    return (React.createElement(React.Fragment, null,
        roles.length > 1 && (React.createElement(RowField, null,
            React.createElement(PicklistField, { id: "role", labelClassName: "font-semibold", label: "Your role", options: roles, value: data.role, placeholder: "Select your role here", alwaysShowLabel: alwaysShowLabel, onChange: function (v) {
                    return onChangeData("role", v);
                } }))),
        React.createElement(RowField, null,
            React.createElement(SingleLineInputField, { id: "email", labelClassName: "font-semibold", onChange: function (v) { return onChangeData("email", v); }, onSubmit: onPressEnterEmail, disabled: disabled, format: "email", borderType: "bottom", placeholder: "Type your email here", value: isNonEmptyString(data.email) ? data.email : "", alwaysShowLabel: alwaysShowLabel, label: "Your email address" })),
        React.createElement(RowField, null,
            React.createElement(SingleLineInputField, { id: "password", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) { return onChangeData("password", v); }, onKeyPress: onPressEnterPassword, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Type your password here", label: "Your password", alwaysShowLabel: alwaysShowLabel, value: isNonEmptyString(data.password) ? data.password : "" })),
        React.createElement(RowField, null,
            React.createElement(SingleLineInputField, { id: "confirmPassword", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) {
                    return onChangeData("confirmPassword", v);
                }, onKeyPress: onPressEnterConfirmPassword, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Confirm your password here", label: "Confirm your password", alwaysShowLabel: alwaysShowLabel, value: isNonEmptyString(data.confirmPassword)
                    ? data.confirmPassword
                    : "" })),
        agreement && agreement.title && (React.createElement(RowField, { className: "mt-20" },
            React.createElement(LabelField, { id: "agreentLabel", line: "Agreement & Notice" }))),
        agreement && agreement.title && (React.createElement(RowField, null,
            React.createElement(LinkField, { id: "showAgreement", type: "info", onClick: function () {
                    onShowAgreement && onShowAgreement();
                } },
                React.createElement("span", null, agreement.onClickText
                    ? agreement.onClickText
                    : "Click here to read the content")))),
        agreement && agreement.title && (React.createElement(RowField, null,
            React.createElement(CheckboxField, { id: "signedAgreement", label: agreement.title, value: data.signedAgreement == true, onChange: function (v) {
                    onChangeData("signedAgreement", v);
                } })))));
};
export var SignUpForm = function (props) {
    var alwaysShowLabel = props.alwaysShowLabel, agreement = props.agreement;
    var _a = useState(props.doing), doing = _a[0], setDoing = _a[1];
    var _b = useState(props.errorMessage), errorMessage = _b[0], setErrorMessage = _b[1];
    var _c = useState({}), data = _c[0], setData = _c[1];
    useEffect(function () {
        setData(props.data);
    }, [props.data]);
    useEffect(function () {
        setErrorMessage(props.errorMessage);
    }, [props.errorMessage]);
    useEffect(function () {
        if (props.doing !== doing)
            setDoing(props.doing);
    }, [props.doing]);
    var onChangeData = function (fieldName, value) {
        setErrorMessage("");
        data[fieldName] = value;
        setData(__assign({}, data));
        if (props.onChangeData)
            props.onChangeData(data);
    };
    var onSubmitConfirmPassword = function () {
        if (props.onSubmitPassword)
            props.onSubmitPassword(data);
    };
    var onShowAgreement = function () {
        props.onShowAgreement && props.onShowAgreement();
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(SignUpFields, { onSubmitConfirmPassword: onSubmitConfirmPassword, onShowAgreement: onShowAgreement, alwaysShowLabel: alwaysShowLabel, data: data, onChangeData: onChangeData, disabled: doing, agreement: agreement }),
        props.children,
        React.createElement(MessageField, { hideIcon: true, line: errorMessage, type: "error", hidden: !isNonEmptyString(errorMessage) })));
};
export default SignUpForm;
//# sourceMappingURL=sign-up.js.map